#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <pwd.h>
#include <errno.h>
#include <time.h>
#define DATE_FILE "log.txt"
     
/* Remember the effective and real UIDs. */
     
static uid_t euid, ruid;
struct passwd pwd;
struct passwd *res;
char *buffer;
size_t bufsize;
int s;
     
/* Restore the effective UID to its original value. */

void print_users(void)
{
	bufsize = sysconf(_SC_GETPW_R_SIZE_MAX);
	buffer = malloc(bufsize);
	s = getpwuid_r(geteuid(), &pwd, buffer, bufsize, &res);
	printf("Effective user name: %s; UID: %ld\n", pwd.pw_name, (long) pwd.pw_uid);
	s = getpwuid_r(getuid(), &pwd, buffer, bufsize, &res);
	printf("Real user name: %s; UID: %ld\n", pwd.pw_name, (long) pwd.pw_uid);
	free(buffer);
}
     
void do_setuid (void)
{
	int status;

	#ifdef _POSIX_SAVED_IDS
		status = seteuid (euid);
	#else
		status = setreuid (ruid, euid);
	#endif

	printf("\nSetuid on\n");
	print_users();
	getchar();

	if (status < 0) {
		fprintf (stderr, "Couldn't set uid.\n");
		exit (status);
	}
}
     

/* Set the effective UID to the real UID. */
     
void undo_setuid (void)
{
	int status;

	#ifdef _POSIX_SAVED_IDS
		status = seteuid (ruid);
	#else
		status = setreuid (euid, ruid);
	#endif
	printf("\nSetuid off\n");
	print_users();
	getchar();

	if (status < 0) {
		fprintf (stderr, "Couldn't set uid.\n");
		exit (status);
	}
}


int record ()
{
	int fd;
	char *myname;
	char buf[100];
	time_t t = time(NULL);
	struct tm tm = *localtime(&t);
	/* Open the date file. */
	printf("\nWanting to open the file\n");
	do_setuid ();
	fd = open (DATE_FILE, O_RDWR, 0644);

	printf("\nFile opened, giving up setuid\n");
	undo_setuid ();

	memset(&buf,0,100);
	/* Write date to file. */
	if (fd)
	{
		myname = cuserid (NULL);
		snprintf (buf, 100, "%10s: %d-%d-%d %d:%d:%d\n", myname, tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec);
		lseek(fd, 0, SEEK_END);
		write(fd, buf, sizeof(buf));
		close (fd);
		printf("\nFile closed, process done\n");
		return 0;
	}
	else
		exit (-1);
}
     
/* Main program. */
     
int main (void)
{
	/* Remember the real and effective user IDs.  */
	ruid = getuid ();
	euid = geteuid ();
	printf("\nProcess started\n");
	printf("\nSetuid on\n");
	print_users();
	getchar();
	

	printf("\nGiving up setuid until opening the file\n");
	undo_setuid ();
	record ();
	return 0;
}

     

